/*
File: ServerApp.java
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


import java.net.*;
import java.lang.*;
import java.io.*;
import threads.ComThread;
import threads.ThreadIn;
import threads.ThreadOut;
import threads.DbThread;



public class ServerApp {

  public static void main(String args[]) {


    int port;

    FileOutputStream fout;

    try {
    fout = new FileOutputStream("../logs/server_log");
    } catch(Exception e) {

      System.out.println("ServerApp: " + e);
      fout = null;
      System.exit(1);
    }
    PrintStream pout = new PrintStream(fout);
    

    try {
      port = Integer.parseInt(args[0]);

    } catch(Exception e) {

        port = 6000;
    }
    
    Server s = new Server(port); 

    System.out = pout;
    System.err = pout;

    s.run();

  }



}

class Server {

 
  private int port;
  ComThread c;
  DbThread d;

  public Server(int p) {

    port = p;
  }



  public void run() {

    Socket conn;
   
    
    try {
      
      ServerSocket socket = new ServerSocket(port);

      System.out.println("Server started on port " + port);
   
       c = new ComThread();
       d = new DbThread();

       c.start();   
       d.start();
        
      do {

	  conn = socket.accept();
          handleConnection(conn);
	
      } while (1 == 1);
   
    } catch(Exception e) {

        System.out.println("Err: " + e);
    }

  }


  private void handleConnection(Socket sock) {

   
    ThreadIn i;
    ThreadOut o;
  
    
     System.out.println("Connection accepted, starting threads ......");
     o = new ThreadOut(sock);   
     i = new ThreadIn(c, d, o, sock);
   
  }

      

}




